package immibis.ccperiphs;

import immibis.ccperiphs.rfid.TileMagStripe;
import immibis.ccperiphs.rfid.TileRFIDReader;
import immibis.ccperiphs.rfid.TileRFIDWriter;
import java.lang.reflect.InvocationTargetException;

public enum EnumPeriphs
{
    RFID_WRITER("RFID writer", TileRFIDWriter.class),
    RFID_READER("RFID reader", TileRFIDReader.class),
    MAG_STRIPE("Mag-card device", TileMagStripe.class);
    public final String name;
    public final Class teclass;

    private EnumPeriphs(String var3, Class var4)
    {
        this.name = var3;
        this.teclass = var4;
    }

    public TilePeriphs createTile()
    {
        try
        {
            return (TilePeriphs)this.teclass.getConstructor(new Class[0]).newInstance(new Object[0]);
        }
        catch (InstantiationException var2)
        {
            throw new RuntimeException(var2);
        }
        catch (InvocationTargetException var3)
        {
            throw new RuntimeException(var3);
        }
        catch (NoSuchMethodException var4)
        {
            throw new RuntimeException(var4);
        }
        catch (IllegalAccessException var5)
        {
            throw new RuntimeException(var5);
        }
    }
}
