package immibis.ccperiphs;

import forge.IGuiHandler;
import forge.MinecraftForge;
import immibis.ccperiphs.rfid.ContainerRFIDWriter;
import immibis.ccperiphs.rfid.DyeCardRecipe;
import immibis.ccperiphs.rfid.ItemCardBase;
import immibis.ccperiphs.rfid.TileMagStripe;
import immibis.ccperiphs.rfid.TileRFIDReader;
import immibis.ccperiphs.rfid.TileRFIDWriter;
import immibis.core.CompatibleBaseMod;
import immibis.core.Config;
import immibis.core.CoreProxy;
import immibis.core.IBlockIDCallback;
import immibis.core.ModInfoReader;
import immibis.core.NonSharedProxy;
import net.minecraft.server.Block;
import net.minecraft.server.CraftingManager;
import net.minecraft.server.EntityHuman;
import net.minecraft.server.Item;
import net.minecraft.server.ItemStack;
import net.minecraft.server.ModLoader;
import net.minecraft.server.TileEntity;
import net.minecraft.server.World;

public class mod_ImmibisPeripherals extends CompatibleBaseMod implements IGuiHandler
{
    public static BlockPeriphs block;
    public static ItemCardBase itemRFID;
    public static ItemCardBase itemMagStripe;
    public static mod_ImmibisPeripherals instance;
    public static final int GUI_RFID_WRITER = 0;

    public String getPriorities()
    {
        return "after:mod_ImmibisCore";
    }

    public mod_ImmibisPeripherals()
    {
        instance = this;
    }

    public String getVersion()
    {
        return ModInfoReader.getModInfoField("/immibis/ccperiphs/mod_ImmibisPeripherals.info.txt", "version");
    }

    public void load()
    {
        CoreProxy.RegisterBlockID("peripherals.block", new IBlockIDCallback()
        {
            public void registerBlock(int var1)
            {
                mod_ImmibisPeripherals.block = new BlockPeriphs(var1);
                ModLoader.registerBlock(mod_ImmibisPeripherals.block, ItemPeriphs.class);
            }
        });
        BlockPeriphs.model = NonSharedProxy.getUniqueBlockModelID(this, true);
        itemRFID = new ItemCardBase(Config.getItemID("peripherals.rfid", 7434) - 256, 48);
        itemMagStripe = new ItemCardBase(Config.getItemID("peripherals.magstripe", 7435) - 256, 64);
        ModLoader.addName(itemRFID, "RFID card");
        ModLoader.addName(itemMagStripe, "Mag-stripe card");
        CraftingManager.getInstance().getRecipies().add(new DyeCardRecipe(itemRFID.id));
        CraftingManager.getInstance().getRecipies().add(new DyeCardRecipe(itemMagStripe.id));
        ModLoader.registerTileEntity(TileRFIDWriter.class, "immibis.cc-rfid.writer");
        ModLoader.registerTileEntity(TileRFIDReader.class, "immibis.cc-rfid.reader");
        ModLoader.registerTileEntity(TileMagStripe.class, "immibis.cc-rfid.msreader");
        MinecraftForge.setGuiHandler(this, this);
    }

    public void modsLoaded()
    {
        ModLoader.addRecipe(new ItemStack(itemRFID, 1, 0), new Object[] {"RRR", "PPP", "RRR", 'P', Item.PAPER, 'R', Item.REDSTONE});
        ModLoader.addRecipe(new ItemStack(itemMagStripe, 1, 0), new Object[] {"PPP", "IRI", 'P', Item.PAPER, 'R', Item.REDSTONE, 'I', Item.IRON_INGOT});
        ModLoader.addRecipe(new ItemStack(block, 1, EnumPeriphs.RFID_READER.ordinal()), new Object[] {" T ", "SIS", "SRS", 'S', Block.STONE, 'T', Block.REDSTONE_TORCH_ON, 'R', Item.REDSTONE, 'I', Item.IRON_INGOT});
        ModLoader.addRecipe(new ItemStack(block, 1, EnumPeriphs.RFID_WRITER.ordinal()), new Object[] {"L-L", "# #", "SRS", 'S', Block.STONE, 'R', Item.DIODE, '#', Block.GOLD_BLOCK, '-', Block.THIN_GLASS, 'L', Block.REDSTONE_LAMP_OFF});
        ModLoader.addRecipe(new ItemStack(block, 1, EnumPeriphs.MAG_STRIPE.ordinal()), new Object[] {"STS", "SRS", "SSS", 'S', Block.STONE, 'R', Item.REDSTONE, 'T', Block.REDSTONE_TORCH_ON});
    }

    public Object getGuiElement(int var1, EntityHuman var2, World var3, int var4, int var5, int var6)
    {
        TileEntity var7 = var3.getTileEntity(var4, var5, var6);

        switch (var1)
        {
            case 0:
                return new ContainerRFIDWriter(var2, (TileRFIDWriter)var7);

            default:
                return null;
        }
    }
}
